<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>screenlets.install</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="screenlets-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            >Screenlets 0.1.2</th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="screenlets-module.html">Package&nbsp;screenlets</a> ::
        Module&nbsp;install
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="screenlets.install-pysrc.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="screenlets.install-module.html">Module screenlets.install</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment"># This application is released under the GNU General Public License </tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># v3 (or, at your option, any later version). You can find the full </tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># text of the license under http://www.gnu.org/licenses/gpl.txt. </tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># By using, editing and/or distributing this software you agree to </tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># the terms and conditions of this license. </tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"></tt><tt class="py-comment"># Thank you for using free software!</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment"></tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment">#  screenlets.install (c) Whise (Helder Fraga) 2008 &lt;helder.fraga@hotmail.com&gt;</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"></tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt id="link-0" class="py-name" targets="Package screenlets=screenlets-module.html"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-0', 'screenlets', 'link-0');">screenlets</a></tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-1" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-1', 'screenlets', 'link-0');">screenlets</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Module screenlets.utils=screenlets.utils-module.html"><a title="screenlets.utils" class="py-name" href="#" onclick="return doclink('link-2', 'utils', 'link-2');">utils</a></tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">os</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">gettext</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-name">gettext</tt><tt class="py-op">.</tt><tt class="py-name">textdomain</tt><tt class="py-op">(</tt><tt class="py-string">'screenlets'</tt><tt class="py-op">)</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-name">gettext</tt><tt class="py-op">.</tt><tt class="py-name">bindtextdomain</tt><tt class="py-op">(</tt><tt class="py-string">'screenlets'</tt><tt class="py-op">,</tt> <tt class="py-string">'/usr/share/locale'</tt><tt class="py-op">)</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-comment"># stub for gettext</tt> </tt>
<a name="_"></a><div id="_-def"><a name="L20"></a><tt class="py-lineno"> 20</tt> <a class="py-toggle" href="#" id="_-toggle" onclick="return toggle('_');">-</a><tt class="py-line"><tt class="py-comment"></tt><tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.install-module.html#_">_</a><tt class="py-op">(</tt><tt class="py-param">s</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="_-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="_-expanded"><a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line">        <tt class="py-comment">#return s</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-comment"></tt>        <tt class="py-keyword">return</tt> <tt class="py-name">gettext</tt><tt class="py-op">.</tt><tt class="py-name">gettext</tt><tt class="py-op">(</tt><tt class="py-name">s</tt><tt class="py-op">)</tt> </tt>
</div><a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt class="py-keyword">if</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">geteuid</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">==</tt><tt class="py-number">0</tt><tt class="py-op">:</tt> </tt>
<a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line">        <tt class="py-comment"># we run as root, install system-wide</tt> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"><tt class="py-comment"></tt>        <tt id="link-3" class="py-name" targets="Variable screenlets.install.USER=screenlets.install-module.html#USER,Variable screenlets.utils.USER=screenlets.utils-module.html#USER"><a title="screenlets.install.USER
screenlets.utils.USER" class="py-name" href="#" onclick="return doclink('link-3', 'USER', 'link-3');">USER</a></tt> <tt class="py-op">=</tt> <tt class="py-number">0</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line">        <tt id="link-4" class="py-name" targets="Variable screenlets.install.DIR_USER=screenlets.install-module.html#DIR_USER,Variable screenlets.utils.DIR_USER=screenlets.utils-module.html#DIR_USER"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-4', 'DIR_USER', 'link-4');">DIR_USER</a></tt>                <tt class="py-op">=</tt> <tt id="link-5" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-5', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-6" class="py-name" targets="Variable screenlets.DIR_USER_ROOT=screenlets-module.html#DIR_USER_ROOT"><a title="screenlets.DIR_USER_ROOT" class="py-name" href="#" onclick="return doclink('link-6', 'DIR_USER_ROOT', 'link-6');">DIR_USER_ROOT</a></tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line">        <tt id="link-7" class="py-name" targets="Variable screenlets.install.DIR_AUTOSTART=screenlets.install-module.html#DIR_AUTOSTART,Variable screenlets.utils.DIR_AUTOSTART=screenlets.utils-module.html#DIR_AUTOSTART"><a title="screenlets.install.DIR_AUTOSTART
screenlets.utils.DIR_AUTOSTART" class="py-name" href="#" onclick="return doclink('link-7', 'DIR_AUTOSTART', 'link-7');">DIR_AUTOSTART</a></tt>   <tt class="py-op">=</tt> <tt class="py-string">'/etc/xdg/autostart'</tt>                  <tt class="py-comment"># TODO: use pyxdg here</tt> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line">        <tt class="py-comment"># we run as normal user, install into $HOME</tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"><tt class="py-comment"></tt>        <tt id="link-8" class="py-name"><a title="screenlets.install.USER
screenlets.utils.USER" class="py-name" href="#" onclick="return doclink('link-8', 'USER', 'link-3');">USER</a></tt> <tt class="py-op">=</tt> <tt class="py-number">1</tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line">        <tt id="link-9" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-9', 'DIR_USER', 'link-4');">DIR_USER</a></tt>                <tt class="py-op">=</tt> <tt id="link-10" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-10', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-11" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-11', 'DIR_USER', 'link-4');">DIR_USER</a></tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line">        <tt id="link-12" class="py-name"><a title="screenlets.install.DIR_AUTOSTART
screenlets.utils.DIR_AUTOSTART" class="py-name" href="#" onclick="return doclink('link-12', 'DIR_AUTOSTART', 'link-7');">DIR_AUTOSTART</a></tt> <tt class="py-op">=</tt> <tt id="link-13" class="py-name"><a title="screenlets.utils" class="py-name" href="#" onclick="return doclink('link-13', 'utils', 'link-2');">utils</a></tt><tt class="py-op">.</tt><tt id="link-14" class="py-name" targets="Function screenlets.utils.get_autostart_dir()=screenlets.utils-module.html#get_autostart_dir"><a title="screenlets.utils.get_autostart_dir" class="py-name" href="#" onclick="return doclink('link-14', 'get_autostart_dir', 'link-14');">get_autostart_dir</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"> </tt>
<a name="ScreenletInstaller"></a><div id="ScreenletInstaller-def"><a name="L36"></a><tt class="py-lineno"> 36</tt> <a class="py-toggle" href="#" id="ScreenletInstaller-toggle" onclick="return toggle('ScreenletInstaller');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="screenlets.install.ScreenletInstaller-class.html">ScreenletInstaller</a><tt class="py-op">:</tt> </tt>
</div><div id="ScreenletInstaller-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="ScreenletInstaller-expanded"><a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line">        <tt class="py-docstring">"""A simple utility to install screenlets into the current user's directory </tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"><tt class="py-docstring">        (so either into $HOME/.screenlets/ for normal users or, if run as root, </tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"><tt class="py-docstring">        into screenlets.INSTALL_PREFIX/share/screenlets/)."""</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line">         </tt>
<a name="ScreenletInstaller.__init__"></a><div id="ScreenletInstaller.__init__-def"><a name="L41"></a><tt class="py-lineno"> 41</tt> <a class="py-toggle" href="#" id="ScreenletInstaller.__init__-toggle" onclick="return toggle('ScreenletInstaller.__init__');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.install.ScreenletInstaller-class.html#__init__">__init__</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ScreenletInstaller.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="ScreenletInstaller.__init__-expanded"><a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line">                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt class="py-string">''</tt> </tt>
</div><a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line">         </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line">         </tt>
<a name="ScreenletInstaller.get_info_from_package_name"></a><div id="ScreenletInstaller.get_info_from_package_name-def"><a name="L45"></a><tt class="py-lineno"> 45</tt> <a class="py-toggle" href="#" id="ScreenletInstaller.get_info_from_package_name-toggle" onclick="return toggle('ScreenletInstaller.get_info_from_package_name');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.install.ScreenletInstaller-class.html#get_info_from_package_name">get_info_from_package_name</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">filename</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ScreenletInstaller.get_info_from_package_name-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="ScreenletInstaller.get_info_from_package_name-expanded"><a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line">                <tt class="py-docstring">"""Return all info we can get from the package-name or return None</tt> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line"><tt class="py-docstring">                if something went wrong. If nothing failed, the returned value is</tt> </tt>
<a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line"><tt class="py-docstring">                a 4-tuple of the form: (name, version, basename, extension)."""</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">                <tt class="py-name">base</tt>    <tt class="py-op">=</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Variable screenlets.ScreenletTheme.path=screenlets.ScreenletTheme-class.html#path,Variable screenlets.backend.CachingBackend.path=screenlets.backend.CachingBackend-class.html#path"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-15', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">basename</tt><tt class="py-op">(</tt><tt class="py-name">filename</tt><tt class="py-op">)</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line">                <tt class="py-name">ext</tt>             <tt class="py-op">=</tt> <tt id="link-16" class="py-name" targets="Method screenlets.plugins.Convert.Converter.str()=screenlets.plugins.Convert.Converter-class.html#str"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-16', 'str', 'link-16');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">filename</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-name">len</tt><tt class="py-op">(</tt><tt id="link-17" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-17', 'str', 'link-16');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">filename</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> <tt class="py-op">-</tt><tt class="py-number">3</tt><tt class="py-op">:</tt><tt class="py-op">]</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line">                <tt class="py-comment"># prepend "tar." if we have a bz2 or gz archive</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">tar_opts</tt> <tt class="py-op">=</tt> <tt class="py-string">'xfz'</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">ext</tt> <tt class="py-op">==</tt> <tt class="py-string">'bz2'</tt><tt class="py-op">:</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line">                        <tt class="py-name">tar_opts</tt> <tt class="py-op">=</tt> <tt class="py-string">'xfj'</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">ext</tt> <tt class="py-op">==</tt> <tt class="py-string">'skz'</tt><tt class="py-op">:</tt>  </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">                        <tt id="link-18" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-18', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-19" class="py-name" targets="Function screenlets.show_error()=screenlets-module.html#show_error"><a title="screenlets.show_error" class="py-name" href="#" onclick="return doclink('link-19', 'show_error', 'link-19');">show_error</a></tt><tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt id="link-20" class="py-name" targets="Function screenlets._()=screenlets-module.html#_,Function screenlets.backend._()=screenlets.backend-module.html#_,Function screenlets.install._()=screenlets.install-module.html#_,Function screenlets.menu._()=screenlets.menu-module.html#_,Function screenlets.options._()=screenlets.options-module.html#_,Function screenlets.sensors._()=screenlets.sensors-module.html#_,Function screenlets.services._()=screenlets.services-module.html#_,Function screenlets.session._()=screenlets.session-module.html#_,Function screenlets.utils._()=screenlets.utils-module.html#_"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-20', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">'This type of karamba theme is not supported yet\n Only older versions can be used'</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line">                <tt class="py-comment"># extract archive to temporary dir</tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"><tt class="py-comment"></tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-21" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-21', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isdir</tt><tt class="py-op">(</tt><tt class="py-string">'/tmp/screenlets/'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line">                        <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mkdir '</tt> <tt class="py-op">+</tt> <tt class="py-string">'/tmp/screenlets/'</tt><tt class="py-op">)</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'rm -rf /tmp/screenlets/install-temp'</tt><tt class="py-op">)</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt><tt class="py-op">:</tt> <tt class="py-keyword">pass</tt>             </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">                <tt class="py-name">tmpdir</tt> <tt class="py-op">=</tt> <tt class="py-string">'/tmp/screenlets'</tt> <tt class="py-op">+</tt> <tt class="py-string">'/install-temp/'</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mkdir %s'</tt> <tt class="py-op">%</tt> <tt class="py-name">tmpdir</tt><tt class="py-op">)</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line">                 </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">                 </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line"> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'tar %s %s -C %s'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">tar_opts</tt><tt class="py-op">,</tt> <tt class="py-name">chr</tt><tt class="py-op">(</tt><tt class="py-number">34</tt><tt class="py-op">)</tt><tt class="py-op">+</tt><tt class="py-name">filename</tt><tt class="py-op">+</tt><tt class="py-name">chr</tt><tt class="py-op">(</tt><tt class="py-number">34</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> <tt class="py-name">tmpdir</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line">                <tt class="py-keyword">for</tt> <tt class="py-name">dd</tt> <tt class="py-keyword">in</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">listdir</tt><tt class="py-op">(</tt><tt class="py-name">tmpdir</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt id="link-22" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-22', 'str', 'link-16');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">dd</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">endswith</tt><tt class="py-op">(</tt><tt class="py-string">'.theme'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mv '</tt> <tt class="py-op">+</tt> <tt class="py-name">tmpdir</tt> <tt class="py-op">+</tt> <tt class="py-string">' '</tt> <tt class="py-op">+</tt> <tt class="py-string">'/tmp/screenlets/'</tt> <tt class="py-op">+</tt> <tt class="py-name">dd</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">6</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mkdir %s'</tt> <tt class="py-op">%</tt> <tt class="py-name">tmpdir</tt><tt class="py-op">)</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mv '</tt> <tt class="py-op">+</tt> <tt class="py-string">'/tmp/screenlets/'</tt> <tt class="py-op">+</tt> <tt class="py-name">dd</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">6</tt><tt class="py-op">]</tt> <tt class="py-op">+</tt> <tt class="py-string">' '</tt><tt class="py-op">+</tt> <tt class="py-name">tmpdir</tt><tt class="py-op">)</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">                                <tt id="link-23" class="py-name" targets="Variable screenlets.plugins.keyring.KeyRing.Key.name=screenlets.plugins.keyring.KeyRing.Key-class.html#name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-23', 'name', 'link-23');">name</a></tt> <tt class="py-op">=</tt> <tt class="py-name">dd</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">6</tt><tt class="py-op">]</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">                                <tt class="py-keyword">return</tt> <tt class="py-op">(</tt><tt id="link-24" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-24', 'name', 'link-23');">name</a></tt><tt class="py-op">,</tt> <tt class="py-name">ext</tt><tt class="py-op">)</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line"> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">                <tt class="py-keyword">for</tt> <tt class="py-name">d</tt> <tt class="py-keyword">in</tt> <tt class="py-name">tmpdir</tt> <tt class="py-op">:</tt> <tt class="py-comment">#for each item in folders</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-25" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-25', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">exists</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">)</tt> <tt class="py-keyword">and</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-26', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isdir</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> <tt class="py-comment">#is it a valid folder?</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">                                <tt class="py-keyword">for</tt> <tt class="py-name">f</tt> <tt class="py-keyword">in</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">listdir</tt><tt class="py-op">(</tt><tt class="py-name">tmpdir</tt><tt class="py-op">)</tt><tt class="py-op">:</tt>  </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">                                         </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">                                        <tt id="link-27" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-27', 'name', 'link-23');">name</a></tt> <tt class="py-op">=</tt> <tt class="py-name">f</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">                <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">                        <tt class="py-keyword">print</tt> <tt id="link-28" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-28', 'name', 'link-23');">name</a></tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> <tt class="py-op">(</tt><tt id="link-29" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-29', 'name', 'link-23');">name</a></tt><tt class="py-op">,</tt> <tt class="py-name">ext</tt><tt class="py-op">)</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">                <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line"> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
</div><a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">         </tt>
<a name="ScreenletInstaller.get_result_message"></a><div id="ScreenletInstaller.get_result_message-def"><a name="L90"></a><tt class="py-lineno"> 90</tt> <a class="py-toggle" href="#" id="ScreenletInstaller.get_result_message-toggle" onclick="return toggle('ScreenletInstaller.get_result_message');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.install.ScreenletInstaller-class.html#get_result_message">get_result_message</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ScreenletInstaller.get_result_message-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="ScreenletInstaller.get_result_message-expanded"><a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">                <tt class="py-docstring">"""Return a human-readable result message about the last operation."""</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> </tt>
</div><a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">         </tt>
<a name="ScreenletInstaller.is_installed"></a><div id="ScreenletInstaller.is_installed-def"><a name="L94"></a><tt class="py-lineno"> 94</tt> <a class="py-toggle" href="#" id="ScreenletInstaller.is_installed-toggle" onclick="return toggle('ScreenletInstaller.is_installed');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.install.ScreenletInstaller-class.html#is_installed">is_installed</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">name</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ScreenletInstaller.is_installed-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="ScreenletInstaller.is_installed-expanded"><a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">                <tt class="py-docstring">"""Checks if the given screenlet with the name defined by 'name' </tt> </tt>
<a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line"><tt class="py-docstring">                (without trailing 'Screenlet') is already installed in the current</tt> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt>  <tt class="py-line"><tt class="py-docstring">                install target location."""</tt> </tt>
<a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-30" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-30', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isdir</tt><tt class="py-op">(</tt><tt id="link-31" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-31', 'DIR_USER', 'link-4');">DIR_USER</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt id="link-32" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-32', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line">                         </tt>
<a name="ScreenletInstaller.install"></a><div id="ScreenletInstaller.install-def"><a name="L100"></a><tt class="py-lineno">100</tt> <a class="py-toggle" href="#" id="ScreenletInstaller.install-toggle" onclick="return toggle('ScreenletInstaller.install');">-</a><tt class="py-line">        <tt class="py-keyword">def</tt> <a class="py-def-name" href="screenlets.install.ScreenletInstaller-class.html#install">install</a> <tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">filename</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="ScreenletInstaller.install-collapsed" style="display:none;" pad="+++" indent="++++++++++++"></div><div id="ScreenletInstaller.install-expanded"><a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">                <tt class="py-docstring">"""Install a screenlet from a given archive-file. Extracts the</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line"><tt class="py-docstring">                contents of the archive to the user's screenlet dir."""</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line">                <tt class="py-keyword">print</tt> <tt id="link-33" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-33', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">'Installing %s'</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt class="py-name">filename</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line">                <tt class="py-name">result</tt> <tt class="py-op">=</tt> <tt class="py-name">False</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line">                <tt class="py-comment"># get name of screenlet</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment">#basename       = os.path.basename(filename)</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment">#extension      = os.path.splitext(filename)</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment">#name           = basename[:basename.find('.')]</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment">#print name</tt> </tt>
<a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">info</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-34" class="py-name" targets="Method screenlets.install.ScreenletInstaller.get_info_from_package_name()=screenlets.install.ScreenletInstaller-class.html#get_info_from_package_name"><a title="screenlets.install.ScreenletInstaller.get_info_from_package_name" class="py-name" href="#" onclick="return doclink('link-34', 'get_info_from_package_name', 'link-34');">get_info_from_package_name</a></tt><tt class="py-op">(</tt><tt class="py-name">filename</tt><tt class="py-op">)</tt> </tt>
<a name="L111"></a><tt class="py-lineno">111</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">info</tt> <tt class="py-op">==</tt> <tt class="py-name">False</tt><tt class="py-op">:</tt> </tt>
<a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt><tt class="py-op">=</tt> <tt id="link-35" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-35', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"Archive is damaged or unsupported, use only tar, bz2 or gz."</tt><tt class="py-op">)</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line">                        <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line">                <tt id="link-36" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-36', 'name', 'link-23');">name</a></tt>    <tt class="py-op">=</tt> <tt class="py-name">info</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line">                <tt class="py-name">ext</tt>             <tt class="py-op">=</tt> <tt class="py-name">info</tt><tt class="py-op">[</tt><tt class="py-number">1</tt><tt class="py-op">]</tt> </tt>
<a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line">                 </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line">                <tt class="py-name">tar_opts</tt> <tt class="py-op">=</tt> <tt class="py-string">'xfz'</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-name">ext</tt> <tt class="py-op">==</tt> <tt class="py-string">'bz2'</tt><tt class="py-op">:</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line">                        <tt class="py-name">tar_opts</tt> <tt class="py-op">=</tt> <tt class="py-string">'xfj'</tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line">                         </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line">                         </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line">                <tt class="py-comment"># check if screenlet is already installed</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-comment">#found_path = screenlets.utils.find_first_screenlet_path(name)</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-37" class="py-name" targets="Method screenlets.install.ScreenletInstaller.is_installed()=screenlets.install.ScreenletInstaller-class.html#is_installed"><a title="screenlets.install.ScreenletInstaller.is_installed" class="py-name" href="#" onclick="return doclink('link-37', 'is_installed', 'link-37');">is_installed</a></tt><tt class="py-op">(</tt><tt id="link-38" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-38', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">:</tt><tt class="py-comment">#found_path != None:</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt id="link-39" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-39', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-40" class="py-name" targets="Function screenlets.show_question()=screenlets-module.html#show_question"><a title="screenlets.show_question" class="py-name" href="#" onclick="return doclink('link-40', 'show_question', 'link-40');">show_question</a></tt><tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-op">(</tt><tt id="link-41" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-41', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"The %sScreenlet is already installed in '%s'.\nDo you wish to continue?"</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-42" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-42', 'name', 'link-23');">name</a></tt><tt class="py-op">,</tt> <tt id="link-43" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-43', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">,</tt><tt class="py-op">(</tt><tt id="link-44" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-44', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">'Install %s'</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-45" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-45', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">                                <tt class="py-keyword">pass</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line">                        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line">                                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt><tt class="py-op">=</tt> <tt id="link-46" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-46', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">'%sScreenlet is already installed'</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-47" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-47', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">                                <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line">                <tt class="py-comment"># check extension and create appropriate args for tar</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">tmpdir</tt> <tt class="py-op">=</tt> <tt id="link-48" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-48', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-49" class="py-name" targets="Variable screenlets.DIR_TMP=screenlets-module.html#DIR_TMP"><a title="screenlets.DIR_TMP" class="py-name" href="#" onclick="return doclink('link-49', 'DIR_TMP', 'link-49');">DIR_TMP</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/install-temp'</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">                <tt class="py-comment"># verify contents</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-50" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-50', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isdir</tt><tt class="py-op">(</tt><tt class="py-string">'%s/%s'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">tmpdir</tt><tt class="py-op">,</tt> <tt id="link-51" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-51', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line">                        <tt class="py-comment"># dir missing</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt id="link-52" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-52', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"Invalid archive. Archive must contain a directory with the screenlet's name."</tt><tt class="py-op">)</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">                <tt class="py-keyword">elif</tt> <tt class="py-keyword">not</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-53" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-53', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isfile</tt><tt class="py-op">(</tt><tt class="py-string">'%s/%s/%sScreenlet.py'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">tmpdir</tt><tt class="py-op">,</tt> <tt id="link-54" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-54', 'name', 'link-23');">name</a></tt><tt class="py-op">,</tt> <tt id="link-55" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-55', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line">                        <tt class="py-comment"># Not a screenlet , lets check for karamba theme</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">themename</tt> <tt class="py-op">=</tt> <tt class="py-string">''</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">                        <tt class="py-keyword">for</tt> <tt class="py-name">findtheme</tt> <tt class="py-keyword">in</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">listdir</tt><tt class="py-op">(</tt><tt class="py-string">'%s/%s/'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">tmpdir</tt><tt class="py-op">,</tt> <tt id="link-56" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-56', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt id="link-57" class="py-name"><a title="screenlets.plugins.Convert.Converter.str" class="py-name" href="#" onclick="return doclink('link-57', 'str', 'link-16');">str</a></tt><tt class="py-op">(</tt><tt class="py-name">findtheme</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">lower</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">endswith</tt><tt class="py-op">(</tt><tt class="py-string">'.theme'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line">                                        <tt class="py-keyword">print</tt> <tt class="py-name">findtheme</tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line">                                        <tt class="py-keyword">if</tt> <tt class="py-name">themename</tt> <tt class="py-op">==</tt> <tt class="py-string">''</tt><tt class="py-op">:</tt> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">                                                <tt class="py-keyword">print</tt> <tt class="py-name">tmpdir</tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt><tt class="py-op">+</tt> <tt id="link-58" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-58', 'name', 'link-23');">name</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">themename</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">6</tt><tt class="py-op">]</tt> <tt class="py-op">+</tt> <tt class="py-string">'.py'</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">                                                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-59" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-59', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isfile</tt><tt class="py-op">(</tt><tt class="py-name">tmpdir</tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt><tt class="py-op">+</tt> <tt id="link-60" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-60', 'name', 'link-23');">name</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">findtheme</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">6</tt><tt class="py-op">]</tt> <tt class="py-op">+</tt> <tt class="py-string">'.py'</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line">                                                        <tt class="py-name">themename</tt> <tt class="py-op">=</tt> <tt class="py-name">findtheme</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-op">-</tt><tt class="py-number">6</tt><tt class="py-op">]</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">                                                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">                                                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt id="link-61" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-61', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"Compatibility for this karamba theme is not yet implemented"</tt><tt class="py-op">)</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line">                                                        <tt class="py-keyword">return</tt> <tt class="py-name">False</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-name">themename</tt> <tt class="py-op">!=</tt> <tt class="py-string">''</tt><tt class="py-op">:</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">                                <tt class="py-name">name1</tt> <tt class="py-op">=</tt> <tt id="link-62" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-62', 'name', 'link-23');">name</a></tt><tt class="py-op">.</tt><tt id="link-63" class="py-name" targets="Variable screenlets.plugins.Convert.Converter.replace=screenlets.plugins.Convert.Converter-class.html#replace"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-63', 'replace', 'link-63');">replace</a></tt><tt class="py-op">(</tt><tt class="py-string">' '</tt><tt class="py-op">,</tt><tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">                                <tt class="py-name">name1</tt> <tt class="py-op">=</tt> <tt class="py-name">name1</tt><tt class="py-op">.</tt><tt id="link-64" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-64', 'replace', 'link-63');">replace</a></tt><tt class="py-op">(</tt><tt class="py-string">'-'</tt><tt class="py-op">,</tt><tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">                                <tt class="py-name">name1</tt> <tt class="py-op">=</tt> <tt class="py-name">name1</tt><tt class="py-op">.</tt><tt id="link-65" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-65', 'replace', 'link-63');">replace</a></tt><tt class="py-op">(</tt><tt class="py-string">'.'</tt><tt class="py-op">,</tt><tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line">                                <tt class="py-name">name1</tt> <tt class="py-op">=</tt> <tt class="py-name">name1</tt><tt class="py-op">.</tt><tt id="link-66" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-66', 'replace', 'link-63');">replace</a></tt><tt class="py-op">(</tt><tt class="py-string">'_'</tt><tt class="py-op">,</tt><tt class="py-string">''</tt><tt class="py-op">)</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">                                <tt class="py-keyword">print</tt> <tt class="py-name">name1</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line">                                <tt class="py-comment">#os.system('tar %s %s -C %s' % (tar_opts, chr(34)+filename+chr(34), DIR_USER))</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line"><tt class="py-comment"></tt>                                <tt class="py-comment">#os.system('mkdir %s/%s' % (DIR_USER,name1))</tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line"><tt class="py-comment"></tt>                                <tt class="py-keyword">if</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-67" class="py-name"><a title="screenlets.install.ScreenletInstaller.is_installed" class="py-name" href="#" onclick="return doclink('link-67', 'is_installed', 'link-37');">is_installed</a></tt><tt class="py-op">(</tt><tt class="py-name">name1</tt><tt class="py-op">)</tt><tt class="py-op">:</tt><tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'rm -rf %s/%s'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-68" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-68', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">,</tt> <tt class="py-name">name1</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line">                                 </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mv %s/%s %s/%s '</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">chr</tt><tt class="py-op">(</tt><tt class="py-number">34</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-name">tmpdir</tt><tt class="py-op">,</tt> <tt id="link-69" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-69', 'name', 'link-23');">name</a></tt> <tt class="py-op">+</tt> <tt class="py-name">chr</tt><tt class="py-op">(</tt><tt class="py-number">34</tt><tt class="py-op">)</tt><tt class="py-op">,</tt><tt id="link-70" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-70', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">,</tt><tt class="py-name">name1</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-comment">#tar %s %s -C %s' % (tar_opts, chr(34)+filename+chr(34), DIR_USER))</tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mkdir %s/%s/themes'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-71" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-71', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">,</tt><tt class="py-name">name1</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'mkdir %s/%s/themes/default'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-72" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-72', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">,</tt><tt class="py-name">name1</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line">                                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'cp '</tt> <tt class="py-op">+</tt> <tt id="link-73" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-73', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-74" class="py-name" targets="Variable screenlets.INSTALL_PREFIX=screenlets-module.html#INSTALL_PREFIX"><a title="screenlets.INSTALL_PREFIX" class="py-name" href="#" onclick="return doclink('link-74', 'INSTALL_PREFIX', 'link-74');">INSTALL_PREFIX</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/share/screenlets-manager/karamba.png '</tt> <tt class="py-op">+</tt> <tt id="link-75" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-75', 'DIR_USER', 'link-4');">DIR_USER</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'/themes/default/'</tt><tt class="py-op">)</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-76" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-76', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isfile</tt><tt class="py-op">(</tt><tt id="link-77" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-77', 'DIR_USER', 'link-4');">DIR_USER</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'/icon.png'</tt><tt class="py-op">)</tt> <tt class="py-op">==</tt> <tt class="py-name">False</tt> <tt class="py-keyword">or</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-78" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-78', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isfile</tt><tt class="py-op">(</tt><tt id="link-79" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-79', 'DIR_USER', 'link-4');">DIR_USER</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'/icon.svg'</tt><tt class="py-op">)</tt> <tt class="py-op">==</tt> <tt class="py-name">False</tt><tt class="py-op">:</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">                                        <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'cp '</tt> <tt class="py-op">+</tt> <tt id="link-80" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-80', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-81" class="py-name"><a title="screenlets.INSTALL_PREFIX" class="py-name" href="#" onclick="return doclink('link-81', 'INSTALL_PREFIX', 'link-74');">INSTALL_PREFIX</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/share/screenlets-manager/karamba.png '</tt> <tt class="py-op">+</tt> <tt id="link-82" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-82', 'DIR_USER', 'link-4');">DIR_USER</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'/icon.png'</tt><tt class="py-op">)</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line">                                <tt class="py-name">widgetengine</tt> <tt class="py-op">=</tt> <tt id="link-83" class="py-name" targets="Method screenlets.utils.FileMonitor.open()=screenlets.utils.FileMonitor-class.html#open"><a title="screenlets.utils.FileMonitor.open" class="py-name" href="#" onclick="return doclink('link-83', 'open', 'link-83');">open</a></tt><tt class="py-op">(</tt><tt id="link-84" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-84', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-85" class="py-name"><a title="screenlets.INSTALL_PREFIX" class="py-name" href="#" onclick="return doclink('link-85', 'INSTALL_PREFIX', 'link-74');">INSTALL_PREFIX</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/share/screenlets-manager/KarambaScreenlet.py'</tt><tt class="py-op">,</tt> <tt class="py-string">'r'</tt><tt class="py-op">)</tt> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line">                                <tt class="py-name">enginecopy</tt> <tt class="py-op">=</tt> <tt class="py-name">widgetengine</tt><tt class="py-op">.</tt><tt class="py-name">read</tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line">                                <tt class="py-name">widgetengine</tt><tt class="py-op">.</tt><tt id="link-86" class="py-name" targets="Method screenlets.Screenlet.close()=screenlets.Screenlet-class.html#close,Method screenlets.plugins.Mplayer.Mplayer.close()=screenlets.plugins.Mplayer.Mplayer-class.html#close,Method screenlets.utils.FileMonitor.close()=screenlets.utils.FileMonitor-class.html#close"><a title="screenlets.Screenlet.close
screenlets.plugins.Mplayer.Mplayer.close
screenlets.utils.FileMonitor.close" class="py-name" href="#" onclick="return doclink('link-86', 'close', 'link-86');">close</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt>  <tt class="py-line">                                <tt class="py-name">widgetengine</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line">                                <tt class="py-name">enginecopy</tt> <tt class="py-op">=</tt> <tt class="py-name">enginecopy</tt><tt class="py-op">.</tt><tt id="link-87" class="py-name"><a title="screenlets.plugins.Convert.Converter.replace" class="py-name" href="#" onclick="return doclink('link-87', 'replace', 'link-63');">replace</a></tt><tt class="py-op">(</tt><tt class="py-string">'KarambaScreenlet'</tt><tt class="py-op">,</tt><tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'Screenlet'</tt><tt class="py-op">)</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line"> </tt>
<a name="L172"></a><tt class="py-lineno">172</tt>  <tt class="py-line">                                <tt class="py-name">enginesave</tt> <tt class="py-op">=</tt> <tt id="link-88" class="py-name"><a title="screenlets.utils.FileMonitor.open" class="py-name" href="#" onclick="return doclink('link-88', 'open', 'link-83');">open</a></tt><tt class="py-op">(</tt><tt id="link-89" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-89', 'DIR_USER', 'link-4');">DIR_USER</a></tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'/'</tt> <tt class="py-op">+</tt> <tt class="py-name">name1</tt> <tt class="py-op">+</tt> <tt class="py-string">'Screenlet.py'</tt><tt class="py-op">,</tt><tt class="py-string">'w'</tt><tt class="py-op">)</tt> </tt>
<a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line">                                <tt class="py-name">enginesave</tt><tt class="py-op">.</tt><tt class="py-name">write</tt><tt class="py-op">(</tt><tt class="py-name">enginecopy</tt><tt class="py-op">)</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line">                                <tt class="py-name">enginesave</tt><tt class="py-op">.</tt><tt id="link-90" class="py-name"><a title="screenlets.Screenlet.close
screenlets.plugins.Mplayer.Mplayer.close
screenlets.utils.FileMonitor.close" class="py-name" href="#" onclick="return doclink('link-90', 'close', 'link-86');">close</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line">                                <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt id="link-91" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-91', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"Karamba theme was successfully installed"</tt><tt class="py-op">)</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line">                                <tt class="py-name">result</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt>    </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line">                        <tt class="py-keyword">else</tt><tt class="py-op">:</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt id="link-92" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-92', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"Invalid archive. Archive does not contain a screenlet or a valid karamba theme."</tt><tt class="py-op">)</tt> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line"> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line"> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line">                         </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line"> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line"> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line"> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line"> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line"> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line"> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line"> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line">                        <tt class="py-comment"># check for package-info</tt> </tt>
<a name="L190"></a><tt class="py-lineno">190</tt>  <tt class="py-line"><tt class="py-comment"></tt> </tt>
<a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">                        <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt class="py-name">os</tt><tt class="py-op">.</tt><tt id="link-93" class="py-name"><a title="screenlets.ScreenletTheme.path
screenlets.backend.CachingBackend.path" class="py-name" href="#" onclick="return doclink('link-93', 'path', 'link-15');">path</a></tt><tt class="py-op">.</tt><tt class="py-name">isfile</tt><tt class="py-op">(</tt><tt class="py-string">'%s/%s/Screenlet.package'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">tmpdir</tt><tt class="py-op">,</tt> <tt id="link-94" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-94', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line">                                <tt class="py-keyword">if</tt> <tt id="link-95" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-95', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-96" class="py-name"><a title="screenlets.show_question" class="py-name" href="#" onclick="return doclink('link-96', 'show_question', 'link-40');">show_question</a></tt><tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-op">(</tt><tt id="link-97" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-97', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"%s was not packaged with the screenlet packager. Do you wish to continue and try to install it?"</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-98" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-98', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">,</tt><tt class="py-op">(</tt><tt id="link-99" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-99', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">'Install %s'</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-100" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-100', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line">                                        <tt class="py-keyword">pass</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line">                                <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line">                                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt id="link-101" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-101', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"This package was not packaged with the screenlet packager."</tt><tt class="py-op">)</tt> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">                                        <tt class="py-keyword">return</tt> <tt class="py-name">False</tt>     </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">                         </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line">                        <tt class="py-comment"># copy archive to user dir (and create if not exists)</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt id="link-102" class="py-name"><a title="screenlets.utils" class="py-name" href="#" onclick="return doclink('link-102', 'utils', 'link-2');">utils</a></tt><tt class="py-op">.</tt><tt id="link-103" class="py-name" targets="Function screenlets.utils.create_user_dir()=screenlets.utils-module.html#create_user_dir"><a title="screenlets.utils.create_user_dir" class="py-name" href="#" onclick="return doclink('link-103', 'create_user_dir', 'link-103');">create_user_dir</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line">                        <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'tar %s %s -C %s'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt class="py-name">tar_opts</tt><tt class="py-op">,</tt> <tt class="py-name">chr</tt><tt class="py-op">(</tt><tt class="py-number">34</tt><tt class="py-op">)</tt><tt class="py-op">+</tt><tt class="py-name">filename</tt><tt class="py-op">+</tt><tt class="py-name">chr</tt><tt class="py-op">(</tt><tt class="py-number">34</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> <tt id="link-104" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-104', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line">                        <tt class="py-comment"># delete package info from target dir</tt> </tt>
<a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'rm %s/%s/Screenlet.package'</tt> <tt class="py-op">%</tt> <tt class="py-op">(</tt><tt id="link-105" class="py-name"><a title="screenlets.install.DIR_USER
screenlets.utils.DIR_USER" class="py-name" href="#" onclick="return doclink('link-105', 'DIR_USER', 'link-4');">DIR_USER</a></tt><tt class="py-op">,</tt> <tt id="link-106" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-106', 'name', 'link-23');">name</a></tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L203"></a><tt class="py-lineno">203</tt>  <tt class="py-line">                        <tt class="py-comment"># set msg/result</tt> </tt>
<a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line"><tt class="py-comment"></tt>                        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">_message</tt> <tt class="py-op">=</tt> <tt id="link-107" class="py-name"><a title="screenlets._
screenlets.backend._
screenlets.install._
screenlets.menu._
screenlets.options._
screenlets.sensors._
screenlets.services._
screenlets.session._
screenlets.utils._" class="py-name" href="#" onclick="return doclink('link-107', '_', 'link-20');">_</a></tt><tt class="py-op">(</tt><tt class="py-string">"The %sScreenlet has been succesfully installed."</tt><tt class="py-op">)</tt> <tt class="py-op">%</tt> <tt id="link-108" class="py-name"><a title="screenlets.plugins.keyring.KeyRing.Key.name" class="py-name" href="#" onclick="return doclink('link-108', 'name', 'link-23');">name</a></tt> </tt>
<a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line">                        <tt class="py-name">result</tt> <tt class="py-op">=</tt> <tt class="py-name">True</tt> </tt>
<a name="L206"></a><tt class="py-lineno">206</tt>  <tt class="py-line">                <tt class="py-comment"># remove temp contents</tt> </tt>
<a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-name">os</tt><tt class="py-op">.</tt><tt class="py-name">system</tt><tt class="py-op">(</tt><tt class="py-string">'rm -rf %s/install-temp'</tt> <tt class="py-op">%</tt> <tt id="link-109" class="py-name"><a title="screenlets" class="py-name" href="#" onclick="return doclink('link-109', 'screenlets', 'link-0');">screenlets</a></tt><tt class="py-op">.</tt><tt id="link-110" class="py-name"><a title="screenlets.DIR_TMP" class="py-name" href="#" onclick="return doclink('link-110', 'DIR_TMP', 'link-49');">DIR_TMP</a></tt><tt class="py-op">)</tt> </tt>
<a name="L208"></a><tt class="py-lineno">208</tt>  <tt class="py-line">                <tt class="py-comment"># ready</tt> </tt>
<a name="L209"></a><tt class="py-lineno">209</tt>  <tt class="py-line"><tt class="py-comment"></tt>                <tt class="py-keyword">return</tt> <tt class="py-name">result</tt> </tt>
</div></div><a name="L210"></a><tt class="py-lineno">210</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="screenlets-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            >Screenlets 0.1.2</th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0beta1 on Wed Jun  4 18:52:59 2008
    </td>
    <td align="right" class="footer">
      <a href="http://epydoc.sourceforge.net">http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie()
  // -->
</script>
  
</body>
</html>
